//+------------------------------------------------------------------+
//|                                                   MACD cross.mq4 |
//|                                      Copyright  2006, Eli hayun |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern int       FastEma=5;
extern int       SlowEma=13;
extern int       SignalSMMA=2;
extern int pq =2;
extern int pr = 10;
extern int ps = 5;
extern int trigger =3;
 //extern bool      UseAlert=false;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   for(int i=0; i<limit; i++)
     {
         ExtMapBuffer1[i] = 0; ExtMapBuffer2[i] = 0;
   double macdMain0 = iCustom(NULL, 0,"FXSnipersErgodic_CCITrigger", pq, pr, ps, trigger,0, i);
         double macdMain2 = iCustom(NULL, 0, "FXSnipersErgodic_CCITrigger", pq, pr, ps, trigger,0, i+1);

         double macdSignal0 = iCustom(NULL, 0, "FXSnipersErgodic_CCITrigger",pq, pr, ps, trigger,1, i);
         double macdSignal2 = iCustom(NULL, 0, "FXSnipersErgodic_CCITrigger",pq, pr, ps, trigger,1,i+1);
         
         double macdMain01 = iCustom(NULL, 0,"MACDsmoothed", FastEma, SlowEma, SignalSMMA, 0, i);
         double macdMain21 = iCustom(NULL, 0, "MACDsmoothed", FastEma, SlowEma, SignalSMMA, 0, i+1);

         double macdSignal01 = iCustom(NULL, 0, "MACDsmoothed",FastEma, SlowEma, SignalSMMA, 1, i);
         double macdSignal21 = iCustom(NULL, 0, "MACDsmoothed",FastEma, SlowEma, SignalSMMA, 1, i+1);

       
       
         if (macdMain0 > macdSignal0 && macdMain2 < macdSignal2&&
         macdMain01 > macdSignal01 && macdMain21 < macdSignal21)
            ExtMapBuffer1[i] = iLow(NULL, 0, i+1);
         if (macdMain0 < macdSignal0 && macdMain2 > macdSignal2&&
         macdMain01 < macdSignal01 && macdMain21 > macdSignal21)
            ExtMapBuffer2[i] = iHigh(NULL, 0, i+1);           
     }
   return(0);
  }
//+------------------------------------------------------------------+